﻿// JScript File



var SHIFT_KEY_PRESSED = false;
var POS_LAST_CLICKED = new Array(); // position of the last item clicked in the list (indexed by items group id)



function invokeSelectionChanged(listId, pos1, pos2, isSelect)
{
    Gaia.Control.callPageMethod('items_ClientSelectionChanged', [listId, pos1, pos2, isSelect], null);  
}



function item_Click(listId, pos, draggable)
{
	var isSelect = true;  // true - selecting / false - unselecting

	var eid = listId + pos;
	var isel = document.getElementById(eid);
	var chsel = isel.getElementsByTagName("a")[0];
    if (! isel.isSelected || isel.isSelected == false)
	{
		isel.isSelected = isSelect;
		isel.className = "itemblock selected";
		chsel.className = "item selected";
		if(draggable)
		{
	        isel.onmousedown = initDnDMouseDown;
            document.getElementById('obs').innerHTML = "Drag set on " + eid + "<br/>";
        }
	}
	else
	{
		isSelect = false;
		isel.isSelected = isSelect;
		isel.className = "itemblock unselected";
		chsel.className = "item unselected";
		if(draggable)
		{
		    isel.onmousedown = null;
	        document.getElementById('obs').innerHTML = "Drag removed from " + eid + "<br/>";
	    }
	}

	if (SHIFT_KEY_PRESSED)
	{
	    var list_pos_last_clicked = POS_LAST_CLICKED[listId] || 0;
		if (list_pos_last_clicked < pos)
		{
			for(var i = list_pos_last_clicked; i < pos; i++)
			{
				var eid = listId + i;
				var isel = document.getElementById(eid);
		        var chsel = isel.getElementsByTagName("a")[0];
				if(isSelect == true)
				{
            		isel.className = "itemblock selected";
		            chsel.className = "item selected";
		        }
				else
				{
					isel.className = "itemblock unselected";
					chsel.className = "item unselected";
				}
				isel.isSelected = isSelect;
			}
		}
		else
		if (list_pos_last_clicked > pos)
		{
			for(var i = pos + 1; i <= list_pos_last_clicked; i++)
			{
				var eid = listId + i;
				var isel = document.getElementById(eid);
	            var chsel = isel.getElementsByTagName("a")[0];
			    if(isSelect == true)
        	    {
        		    isel.className = "itemblock selected";
	                chsel.className = "item selected";
			    }
			    else
			    {
				    isel.className = "itemblock unselected";
				    chsel.className = "item unselected";
		        }
   			    isel.isSelected = isSelect;
			}
	    }
	    
		invokeSelectionChanged(listId, list_pos_last_clicked, pos, isSelect);
	}
	else
	{
		invokeSelectionChanged(listId, pos, pos, isSelect);
	}  

	POS_LAST_CLICKED[listId] = pos;

    return false;      // cancel bubble
}



function listenKeydown(ev)
{
    if(!ev) ev = window.event;  // IE fix
    if(ev.keyCode == 16)        // shift key event
    {
       SHIFT_KEY_PRESSED = true;
    }
}



function listenKeyup(ev)
{
    if(!ev) ev = window.event;  // IE fix
    if(ev.keyCode == 16)        // shift key event
    {
       SHIFT_KEY_PRESSED = false;
    }
}



function listenMouseMove(ev)
{
    // if dragging any element
    var dragp = document.getElementById('dragPanel');
    if(! dragp.baseTarget)
        return;
    
    // mouse coordenates
    if(!ev) ev = window.event;  // IE fix
    var x;
    var y;    
	if(ev.pageX && ev.pageY)
	{
		x = ev.pageX;
		y = ev.pageY;
	}
	else                        // IE fix
	{
		x = ev.clientX + document.body.scrollLeft - document.body.clientLeft;
		y = ev.clientY + document.body.scrollTop  - document.body.clientTop;
	}
	
    // check if drag panel is already initialized
    dragp.style.top = (y + 20) + "px";
    dragp.style.left = (x - 10) + "px";
    document.getElementById('obs').innerHTML = "x: " + x + "    y: " + y; 
    if(dragp.className != "dragPanelVisible")
    {
         dragp.className = "dragPanelVisible";
         dragp.innerHTML = dragp.baseTarget.innerHTML;
    }
}



function initDnDMouseDown(ev)
{
    document.getElementById('obs').innerHTML = "Drag init on " + ev.currentTarget.id + "<br/>";
    document.getElementById('dragPanel').baseTarget = ev.currentTarget;
    ev.stopPropagation();
    ev.preventDefault();
    //document.getElementById('dragPanel').baseTarget = null;
}



function initEngine()
{
    document.onkeydown = listenKeydown;
    document.onkeyup = listenKeyup;
    document.onmousemove = listenMouseMove;
}



window.onload = initEngine;
